package org.rcisoft.bus.jnP7sj.controller;

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.bus.jnP7sj.dto.jnP7sjPageHandleDto;
import org.rcisoft.bus.jnP7sj.entity.jnP7sj;
import org.rcisoft.bus.jnP7sj.service.jnP7sjService;
import org.rcisoft.core.anno.CyEncryptSm4Anno;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.controller.CyPaginationController;
import org.rcisoft.core.model.CyGridModel;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.rcisoft.util.ExportToExcelUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;
import java.util.List;

@RestController
@RequestMapping("/jnP7sj")
public class jnP7sjController extends CyPaginationController<jnP7sj> {
    @Autowired
    private jnP7sjService jnP7sjServiceImpl;

    @CyOpeLogAnno(title = "system-jnP7sj管理-新增jnP7sj", businessType = CyLogTypeEnum.INSERT)
    @ApiOperation(value = "添加jnP7sj", notes = "添加jnP7sj")
    @PostMapping(value = "/add")
    public CyResult add(@Valid jnP7sj jnP7sj, BindingResult bindingResult) {
        CyPersistModel data = jnP7sjServiceImpl.persist(jnP7sj);
        return CyResultGenUtil.builder(data, CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR, jnP7sj);
    }

    @CyOpeLogAnno(title = "system-jnP7sj管理-逻辑删除jnP7sj", businessType = CyLogTypeEnum.DELETE)
    @ApiOperation(value = "逻辑删除jnP7sj", notes = "逻辑删除jnP7sj")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @DeleteMapping("/deleteLogical/{businessId:\\w+}")
    public CyResult deleteLogical(@PathVariable Integer businessId, jnP7sj jnP7sj) {
        jnP7sj.setBusinessId(businessId);
        CyPersistModel data = jnP7sjServiceImpl.removeLogical(jnP7sj);
        return CyResultGenUtil.builder(data, CyMessCons.MESSAGE_ALERT_SUCCESS, CyMessCons.MESSAGE_ALERT_ERROR, jnP7sj);
    }

    @CyOpeLogAnno(title = "system-jnP7sj管理-删除jnP7sj", businessType = CyLogTypeEnum.DELETE)
    @ApiOperation(value = "删除jnP7sj", notes = "删除jnP7sj")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @DeleteMapping("/delete/{businessId:\\w+}")
    public CyResult dalete(@PathVariable Integer businessId, jnP7sj jnP7sj) {
        jnP7sj.setBusinessId(businessId);
        CyPersistModel data = jnP7sjServiceImpl.remove(jnP7sj);
        return CyResultGenUtil.builder(data, CyMessCons.MESSAGE_ALERT_SUCCESS, CyMessCons.MESSAGE_ALERT_ERROR, jnP7sj);
    }

    @CyOpeLogAnno(title = "system-jnP7sj管理-修改jnP7sj", businessType = CyLogTypeEnum.UPDATE)
    @ApiOperation(value = "修改jnP7sj", notes = "修改jnP7sj")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PutMapping("/update/{businessId:\\w+}")
    public CyResult update(@PathVariable Integer businessId, jnP7sj jnP7sj) {
        jnP7sj.setBusinessId(businessId);
        CyPersistModel data = jnP7sjServiceImpl.merge(jnP7sj);
        return CyResultGenUtil.builder(data, CyMessCons.MESSAGE_ALERT_SUCCESS, CyMessCons.MESSAGE_ALERT_ERROR, jnP7sj);

    }

    @CyOpeLogAnno(title = "system-jnP7sj管理-查询jnP7sj", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value = "查询单一jnP7sj", notes = "查询单一jnP7sj")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @GetMapping("/detail/{businessId:\\w+}")
    public CyResult detail(@PathVariable Integer businessId) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_ERROR,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnP7sjServiceImpl.findById(businessId));
    }
    @CyOpeLogAnno(title = "system-jnP7sj管理-查询jnP7sj", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value="查询jnP7sj集合", notes="查询jnP7sj集合")
    @GetMapping(value = "/queryjnP7sjs")
    public CyResult queryjnP7sjs(jnP7sj jnP7sj){
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnP7sjServiceImpl.findAll(jnP7sj));
    }
    @CyOpeLogAnno(title = "system-jnP7sj管理-查询jnP7sj", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value="分页查询jnP7sj集合", notes="分页查询jnP7sj集合")
    @GetMapping(value = "/queryjnP7sjByPagination")
    public CyGridModel listByPagination(jnP7sj jnP7sj) {
        jnP7sjServiceImpl.findAllByPagination(getPaginationUtility(), jnP7sj);
        return getGridModelResponse();
    }
    @CyOpeLogAnno(title = "system-jnP7sj管理-查询jnP7sj", businessType = CyLogTypeEnum.EXPORT)
    @ApiOperation(value = "导出jnP7sj信息", notes = "导出jnP7sj信息")
    @GetMapping(value = "/export")
    public void outjnP7sj(HttpServletResponse response, jnP7sj jnP7sj, @PathVariable @RequestParam(defaultValue = "0") String excelId) {
        String excelName="";
        switch(excelId){
            case "0": excelName="jnP7sj信息.xls";break;
            case "1": excelName="jnP7sj信息.xlsx";break;
            case "2": excelName="jnP7sj信息.csv";break;
        }
        List<jnP7sj> jnP7sjList = jnP7sjServiceImpl.export(jnP7sj);
        ExportToExcelUtil.exportExcel(jnP7sjList, "jnP7sj信息", "jnP7sj信息", jnP7sj.class, excelName, response);
    }
    @CyOpeLogAnno(title = "system-jnP7sj管理-查询月份下拉框", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value = "查询月份下拉框", notes = "查询月份下拉框")
    @GetMapping(value = "/getMonth")
    public CyResult getMonth() {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnP7sjServiceImpl.getMonth());
    }
    @CyOpeLogAnno(title = "system-jnP7sj管理-下载空模板", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value = "下载空模板", notes = "下载空模板")
    @GetMapping(value = "/jnP7sjDownEmptyTemplate")
    public void jnP7sjDownEmptyTemplate(jnP7sjPageHandleDto jnP7sjPageHandleDto, HttpServletResponse response) {
        jnP7sjServiceImpl.jnP7sjDownEmptyTemplate(jnP7sjPageHandleDto,response);
    }

    /**
     * 导入模板
     * **/
    @CyOpeLogAnno(title = "system-检查申请管理-jnP7sj导入", businessType = CyLogTypeEnum.IMPORT)
    @ApiOperation(value = "jnP7sj导入", notes = "jnP7sj导入")
    @PostMapping(value = "/jnP7sjImportDtoExcel")
    @CyEncryptSm4Anno
    public CyResult jnP7sjImportDtoExcel(MultipartFile file) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnP7sjServiceImpl.jnP7sjImportDtoExcel(file));
    }
}
